function getDirname(path,		pathComponents, dirname) {
	dirname = ""
	pathComponents[1] = ""

	path = resolvePath(path)
	split(path, pathComponents, "/")

	if (length(pathComponents) < 2) return "."

	for (i = 1; i < length(pathComponents); i++) 
		dirname = dirname pathComponents[i] "/"

	return dirname
}

function resolvePath(path,	resolvedPath, pathComponents) {
	pathComponents[1] = ""
	resolvedPath = ""

	sub(/\/+$/, "", path)
	split(path, pathComponents, "/")

	for (i = 1; i < length(pathComponents) + 1; i++)
		if (pathComponents[i] == "." || pathComponents[i] == "") 
			continue
		else if (pathComponents[i+1] == "..") {
			i++
			continue
		} else
			resolvedPath = resolvedPath pathComponents[i] "/"

	sub(/\/+$/, "", resolvedPath)

	return resolvedPath
}

function getRelativePath(base, path,	resolvedPath, baseComponents, pathComponents, commonPrefix) {
	pathComponents[1] = ""
	baseComponents[1] = ""
	commonPrefixEnd = 1
	resolvedPath = ""

	base = resolvePath(base)
	path = resolvePath(path)

	split(path, pathComponents, "/")
	split(base, baseComponents, "/")

	while (commonPrefixEnd < length(baseComponents) + 1 && 
		commonPrefixEnd < length(pathComponents) + 1 &&
		baseComponents[commonPrefixEnd] == pathComponents[commonPrefixEnd])
		commonPrefixEnd++

	for (i = commonPrefixEnd; i < length(baseComponents) + 1; i++)
		resolvedPath = resolvedPath "../"

	for (i = commonPrefixEnd; i < length(pathComponents) + 1; i++)
		resolvedPath = resolvedPath pathComponents[i] "/"

	sub(/\/+$/, "", resolvedPath)

	return resolvedPath
}
